web_app/user/urls.py
from django.urls import path, include
from .views import RegisterUserView, LoginUserView, ActivateView, AccountView, DeleteAccount, UserUpdatePassword
from django.contrib.auth.views import LogoutView

app_name = 'user'

urlpatterns = [
    path('register/', RegisterUserView.as_view(), name='register'),
    path('login/', LoginUserView.as_view(), name='login'),
    path('logout/', LogoutView.as_view(), name='logout'),
    path('account/', AccountView.as_view(), name='account'),
    path('account/password/<pk>', UserUpdatePassword.as_view(), name='account-password'),
    path('account/delete/<pk>', DeleteAccount.as_view(), name='account-delete'),
    path('confirm-account/<token>/', ActivateView.as_view(), name='confirm-account'),
]

web_app/user/models.py
from django.contrib.auth.models import AbstractUser
from django.urls import reverse
from django.db import models
from uuid import uuid4
from django.db.models.signals import post_save
from django.conf import settings


class User(AbstractUser):

    def get_absolute_url(self):
        return reverse('account-details', kwargs={'pk': self.id})

    def __str__(self):
        return self.username


class ConfirmationToken(models.Model):
    user = models.OneToOneField(
        User,
        on_delete=models.CASCADE,
    )
    token = models.UUIDField(
        primary_key=True,
        default=uuid4,
        editable=False)


def create_token_and_send_confirm_email_post_save(sender, instance, **kwargs):
    from .tasks import task_send_confirmation_email
    if not instance.is_active:
        if ConfirmationToken.objects.filter(user=instance).exists():
            ConfirmationToken.objects.get(user=instance).delete()
        token = ConfirmationToken(user=instance)
        token.save()
        task_send_confirmation_email.delay(instance.pk, token.token)


post_save.connect(create_token_and_send_confirm_email_post_save, sender=User)

web_app/user/forms.py
from django import forms
from django.forms import ModelForm
from .models import User


class UserCreateForm(ModelForm):
    password = forms.CharField(widget=forms.PasswordInput)
    repeat_password = forms.CharField(widget=forms.PasswordInput)

    class Meta:
        model = User
        fields = [
            'username',
            'email',
            'password'
        ]
        help_texts = {
            'username': None,
        }


class UserUpdatePwdForm(ModelForm):
    old_password = forms.CharField(widget=forms.PasswordInput)
    password = forms.CharField(widget=forms.PasswordInput)
    repeat_password = forms.CharField(widget=forms.PasswordInput)

    class Meta:
        model = User
        fields = [
            'password'
        ]

web_app/user/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.http import Http404
from django.urls import reverse_lazy
from django.views import View
from django.views.generic import CreateView, DeleteView, UpdateView
from django.contrib.auth.views import LoginView
from django.shortcuts import render
from .forms import UserCreateForm, UserUpdatePwdForm
from .models import User, ConfirmationToken


class RegisterUserView(CreateView):
    form_class = UserCreateForm
    success_url = reverse_lazy('home')
    template_name = 'user/user_register.html'
    success_message = 'Check you email and confirm registration'

    def form_valid(self, form):

        context = {'form': form}
        username = form.cleaned_data['username']
        email = form.cleaned_data['email']
        password = form.cleaned_data['password']
        repeat_password = form.cleaned_data['repeat_password']

        if password != repeat_password:
            form.error = 'Passwords are not the same'
            return render(self.request, self.template_name, context)
        if email and User.objects.filter(email=email).exists():
            form.error = 'Email is occupied'
            return render(self.request, self.template_name, context)
        if username and User.objects.filter(username=username).exists():
            form.error = 'Username is occupied'
            return render(self.request, self.template_name, context)

        user = form.save(commit=False)
        user.set_password(password)
        user.is_active = False
        return super(RegisterUserView, self).form_valid(form)


class LoginUserView(LoginView):
    template_name = 'user/user_login.html'
    redirect_authenticated_user = True
    success_url = reverse_lazy('home')


class ActivateView(View):
    def get(self, request, token):
        try:
            token_entity = ConfirmationToken.objects.filter(token=token).select_related(
                'user').get()
            user = token_entity.user
            user.is_active = True
            User.objects.filter(pk=user.pk).update(is_active=True)
        except ConfirmationToken.DoesNotExist:
            raise Http404('Address does not exist')
        return render(request, template_name='user/sing_up_confirmed.html', context={})


class AccountView(LoginRequiredMixin, View):
    def get(self, request):
        return render(request, template_name='user/account_view.html', context={})


class DeleteAccount(LoginRequiredMixin, DeleteView):
    model = User
    template_name = 'user/user_confirm_delete.html'
    success_url = reverse_lazy('home')


class UserUpdatePassword(LoginRequiredMixin, UpdateView):
    model = User
    success_url = reverse_lazy('home')
    form_class = UserUpdatePwdForm
    template_name = 'user/user_password.html'

    def form_valid(self, form):
        # TODO checking old password and create new
        return super(UserUpdatePassword, self).form_valid(form)

web_app/user/templates/user/account_view.html
{% extends "base.html" %}

{% block content %}

    <div style="text-align:center; padding-left: 35%; padding-right: 35%; padding-top: 10%">
        <h4>Update password</h4>
        <span style="display:block; width:100%; border-top: 1px solid; color: grey"></span>
        <div style="padding: 2% 10% 0; text-align: center">
            <a class="waves-effect waves-light btn" href="{% url 'user:account-password' user.pk %}">Update</a>
        </div>
        <h4>Delete account</h4>
        <span style="display:block; width:100%; border-top: 1px solid; color: grey"></span>
        <div style="padding: 2% 10% 0; text-align: center">
            <a class="waves-effect waves-light btn" href="{% url 'user:account-delete' user.pk %}">Delete</a>
        </div>
    </div>

{% endblock %}

web_app/user/templates/user/sign_up_email.html
<html>
<head>
</head>
<body>
<h2>{{ subject }}</h2>
<p>{{ message }}</p>
<a href="{{ activate_url }}">ReminderApp</a>
</body>
</html>

web_app/user/templates/user/sing_up_confirmed.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>
<h1>Account activated!</h1>
</body>
</html>

web_app/user/templates/user/user_confirm_delete.html
{% extends "base.html" %}

{% block content %}
    <div style="padding: 10% 25% 5%; text-align: center">
        <form method="post" action="{% url 'user:account-delete' object.pk %}">
            {% csrf_token %}
            <h5 style="color: grey">Are you sure you want to delete "{{ object }}"?</h5>
            <div style="padding: 3%">
                <button class="waves-effect waves-light btn">Delete</button>
            </div>
        </form>
    </div>
{% endblock %}

web_app/user/templates/user/user_login.html
{% extends "base.html" %}

{% block content %}

    <div style="text-align:center; padding-left: 35%; padding-right: 35%; padding-top: 10%">
        <form method="post" action="{% url 'user:login' %}">
            {% csrf_token %}
                {{ form.as_table }}
            <div style="padding: 3%">
                <button class="waves-effect waves-light btn">Login</button>
            </div>
        </form>
        <div>
            <a href="{% url 'user:register' %}">You do not have account? - Register here</a>
        </div>
    </div>

{% endblock %}

web_app/user/templates/user/user_password.html
{% extends "base.html" %}

{% block content %}

    <div style="text-align:center; padding-left: 35%; padding-right: 35%; padding-top: 5%">
        <form method="post" action="{% url 'user:account-password' user.pk %}">
            {% csrf_token %}
            {{ form.as_table }}
            <div style="padding: 3%">
                <button class="btn waves-effect waves-light" type="submit" name="action">Update
                    <i class="material-icons right">send</i>
                </button>
            </div>
        </form>
    </div>


{% endblock %}

web_app/user/templates/user/user_register.html
{% extends "base.html" %}

{% block content %}

    <div style="text-align:center; padding-left: 35%; padding-right: 35%; padding-top: 5%">
        <form method="post" action="{% url 'user:register' %}">
            {% csrf_token %}
            {{ form.as_table }}
            <button class="btn waves-effect waves-light" type="submit" name="action">Register
                <i class="material-icons right">send</i>
            </button>
        </form>
    </div>


{% endblock %}